

-- UPDATE 9/fix_db_20160629.sql

insert into cache_type select 3,365,'lcsb.mapviewer.annotation.services.MiriamConnector' where (select count(*) from cache_type where iddb = 3) =0;

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1022, 'Installation script fixed', 'BUG_FIX', null, null);

insert into framework_version(version,"time", svnversion) values (9, timestamp'2016-06-29',1023);


-- UPDATE 10/fix_db_20160517.sql

-- remove metaid columns (some useless identifier)
alter table species_table drop column metaid;
alter table reaction_table drop column metaid;
alter table model_table drop column metaid;


-- UPDATE 10/fix_db_20160518.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Search by reaction id is not case sensitive', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'CellDesigner font size is processed properly', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));

--column with input file data for a project
alter table project_table add column inputdata bytea;
ALTER TABLE project_table ADD COLUMN inputfilename varchar;

-- UPDATE 10/fix_db_20160519.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Project info tab available for users', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));


-- UPDATE 10/fix_db_20160520.sql

INSERT INTO cache_type(iddb, validity, classname)
VALUES (19, 28, 'lcsb.mapviewer.annotation.services.genome.UcscReferenceGenomeConnector');


-- UPDATE 10/fix_db_20160523.sql

CREATE SEQUENCE public.big_file_entry_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.big_file_entry
(
  iddb integer NOT NULL DEFAULT nextval('big_file_entry_iddb_seq'::regclass),
  url text,
  localpath text,
  downloaddate timestamp without time zone,
  downloadprogress double precision,
  downloadthreadid integer,
  removed boolean default false,
  CONSTRAINT big_file_entry_pkey PRIMARY KEY (iddb)
)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.big_file_entry
  OWNER TO map_viewer;
ALTER TABLE public.big_file_entry_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160524.sql

drop table if exists public.reference_genome;
drop SEQUENCE if exists public.reference_genome_iddb_seq;
CREATE SEQUENCE public.reference_genome_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_iddb_seq'::regclass),
  organism_iddb integer NOT NULL ,
  "type" varchar(255),
  version varchar(255),
  sourceurl text,
  downloadprogress double precision,
  CONSTRAINT reference_genome_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_organism_fk FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION
)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.reference_genome
  OWNER TO map_viewer;
ALTER TABLE public.reference_genome_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160527.sql

--obligatory fields for reference genome table
alter table reference_genome alter column "type" set not null;
alter table reference_genome alter column organism_iddb set not null;
alter table reference_genome alter column "version" set not null;


--gene mapping files table for reference genome table
drop table if exists public.reference_genome_gene_mapping;
drop SEQUENCE if exists public.reference_genome_gene_mapping_iddb_seq;
CREATE SEQUENCE public.reference_genome_gene_mapping_iddb_seq
  INCREMENT 1
  MINVALUE 1
  MAXVALUE 9223372036854775807
  START 1
  CACHE 1;
  
CREATE TABLE public.reference_genome_gene_mapping
(
  iddb integer NOT NULL DEFAULT nextval('reference_genome_gene_mapping_iddb_seq'::regclass),
  referencegenome_iddb integer NOT NULL,
  name varchar(255) not null,
  sourceurl text not null,
  downloadprogress double precision,
  CONSTRAINT reference_genome_gene_mapping_pkey PRIMARY KEY (iddb),
  CONSTRAINT reference_genome_gene_mapping_reference_genome_fk FOREIGN KEY (referencegenome_iddb)
      REFERENCES public.reference_genome (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION,
  CONSTRAINT reference_genome_gene_mapping_unique_name UNIQUE (referencegenome_iddb, name)
      

)
WITH (
  OIDS=FALSE
);

ALTER TABLE public.reference_genome_gene_mapping
  OWNER TO map_viewer;
ALTER TABLE public.reference_genome_gene_mapping_iddb_seq
  OWNER TO map_viewer;

-- UPDATE 10/fix_db_20160601.sql

-- fixing privileges for admin (genome managing is availabvle by default for admin)
insert into privilege_table (privilege_class_type_db,level,type,idobject,user_iddb) select 'BASIC_PRIVILEGE',1,11,null, t.iddb from user_table t where iddb=1 and not(t.iddb in (select user_iddb from privilege_table where type=11));


-- UPDATE 10/fix_db_20160606.sql

-- project should have organism id
alter table project_table  add column organism_iddb integer;
ALTER TABLE project_table ADD CONSTRAINT project_organism_constraint FOREIGN KEY (organism_iddb)
      REFERENCES public.miriam_data_table (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

-- UPDATE 10/fix_db_20160621.sql

-- reorganizing files in the system
alter table big_file_entry rename to file_entry;

alter table file_entry add column filecontent bytea;
alter table file_entry add column file_type_db varchar(255);
alter table file_entry add column originalfilename varchar(255);

-- all files up to this point were big files
update file_entry set file_type_db = 'BIG_FILE_ENTRY';

--and now we move content of files from layout file to file_entry table
--tmp column
alter table file_entry add column layout_id_tmp integer;
--move content content
insert into file_entry (filecontent,file_type_db,originalfilename,layout_id_tmp) select inputdata, 'UPLOADED_FILE_ENTRY', 'layout_'||iddb||'.txt',iddb from layout where inputdata is not null;

--add foreign key
alter table layout add column file_entry_iddb integer;
ALTER TABLE layout ADD CONSTRAINT layout_file_constraint FOREIGN KEY (file_entry_iddb)
      REFERENCES public.file_entry (iddb) MATCH SIMPLE
      ON UPDATE NO ACTION ON DELETE NO ACTION;

--put data to foreign key      
update layout l set file_entry_iddb = (select iddb from file_entry ef where ef.layout_id_tmp = l.iddb) where l.inputdata is not null;

--remove unused columns 
alter table file_entry drop column layout_id_tmp;
alter table layout drop column inputdata;


-- UPDATE 10/fix_db_20160629.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Hiding left panel', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Coordinates in url', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Unexpected errors when uploading layouts', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));

delete from cachequery where type = (select iddb from cache_type where classname = 'lcsb.mapviewer.annotation.services.DrugbankHTMLParser') and query like 'drug:%';

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1024, 'Corrupted drug names', 'BUG_FIX', null, 
  (select iddb from external_user where email ='alberto.noronha@uni.lu'));


-- UPDATE 10/fix_db_20160727.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Out of memory when caching a lot of data', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Management of overlays in admin panel', 'FUNCTIONALITY', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Zooming issue when searching for results on submaps', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  
insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1049, 'Exception when accessing non-existing project', 'BUG_FIX', null, 
  (select iddb from external_user where email ='piotr.gawron@uni.lu'));
  


-- UPDATE 10/fix_db_20160728.sql

insert into changelog (svnversion, description, type, requestproject_iddb, requestuser_iddb) values 
  (1056, 'Visualization of text mining', 'BUG_FIX', null, 
  (select iddb from external_user where email ='marek.ostaszewski@uni.lu'));


-- UPDATE 10/fix_db_20160822.sql

insert into framework_version(version,"time", svnversion) values (10, timestamp'2016-08-22',1119);
